﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Kivii.DataAnnotations;
namespace Kivii.FormMaking.Entities
{

    [Alias(Configs.FormData)]
    [Api(Description = "内容基本信息")]
    public class FormMakingData : EntityWithMetadata, IEntityInAssemblyDb, IEntityHasCreator, IEntityHasUpdater
    {

        #region  内容主体
        [ApiMember(Description = "标题")]
        [StringLength(200)]
        public string Title { get; set; }

        [ApiMember(Description = "内部编码")]
        [StringLength(200)]
        public string InternalCode { get; set; }

        [ApiMember(Description = "实体类型")]
        [StringLength(200)]
        public string EntityType { get; set; }

        [ApiMember(Description = "表单数据")]
        [StringLength(int.MaxValue)]
        public string FormData { get; set; }

        [Required]
        [ApiMember(Description = "表单Kvid ")]
        public Guid FormComponentKvid { get; set; }

        [DefaultEmptyGuid]
        [ApiMember(Description = "作者Kvid ")]
        public Guid AuthorKvid { get; set; }

        [ApiMember(Description = "作者")]
        [StringLength(50)]
        public string AuthorName { get; set; }

        [ApiMember(Description = "备注")]
        [StringLength(500)]
        public string Remark { get; set; }
        #endregion

        #region 时间相关

        [ApiMember(Description = "发布时间")]
        public DateTime? PublishDate { get; set; }

        [ApiMember(Description = "结束倒计时")]
        public DateTime? EndCountDown { get; set; }

        #endregion

        #region 创建/更新人V1.0
        [ApiMember(Description = "创建人Kvid ")]
        [IgnoreUpdate]
        [CurrentMemberKvid]
        public Guid CreatorKvid { get; set; }

        [ApiMember(Description = "创建人")]
        [IgnoreUpdate]
        [StringLength(50), CurrentMemberName]
        public string CreatorName { get; set; }

        [ApiMember(Description = "更新人Kvid ")]
        [CurrentMemberKvid]
        public Guid UpdaterKvid { get; set; }

        [ApiMember(Description = "更新人")]
        [StringLength(50), CurrentMemberName]
        public string UpdaterName { get; set; }
        #endregion
    }
}

